/***************************************************************************

  CWindow.h

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CWINDOW_H
#define __CWINDOW_H

#include "gambas.h"

#include <ClanLib/display.h>
#include <ClanLib/core.h>
#include <ClanLib/gl.h>

class myWindow;

typedef
  struct {
    GB_BASE ob;
	myWindow *window;
  }
  CLDWINDOW;

#ifndef __CWINDOW_CPP
extern GB_DESC CLmainwindow[];
#else

#define THIS      ((CLDWINDOW *)_object)
#define DWINDOW    THIS->window
  
#endif /* __CWINDOW_CPP */
  
class myWindow : public CL_DisplayWindowDescription
{
public:
	myWindow(int width, int height, int depth);

	void setTitle (char *title);
	void show (CLDWINDOW *object);
	void setWidth (int width);
	int height (int height=0);
	void refresh (void);
	void clear (int);

	int getFullscreen (void);
	void setFullscreen (bool);

private:
	/* events */
	void gotFocus (void);
	void lostFocus (void);
	void mainClose (void);

	CL_Slot	GotFocus;
	CL_Slot	LostFocus;
	CL_Slot MainClose;

	/* private datas */
	CL_DisplayWindow *window;
	CLDWINDOW *_cldwindow;
};

#endif /* __CWINDOW_H */
