/***************************************************************************

  CTimer.cpp

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CTIMER_CPP

#include "gambas.h"
#include "main.h"
#include "CTimer.h"

#include <ClanLib/core.h>

DECLARE_EVENT(EVENT_timer);

/**************************************************************************

  Timer

***************************************************************************/

BEGIN_METHOD_VOID(CLTIMER_new)

	CLTIMER = new myTimer(THIS);
	
END_METHOD

BEGIN_METHOD_VOID(CLTIMER_free)

	if (!CLTIMER)
		return;
	
	CLTIMER->disable ();
	delete CLTIMER;

END_METHOD

BEGIN_PROPERTY(CLTIMER_delay)

	if (READ_PROPERTY)
		GB.ReturnInteger(CLTIMER->get_interval ());
	else
		CLTIMER->set_interval (VPROP(GB_INTEGER));
	
END_METHOD

BEGIN_PROPERTY(CLTIMER_Enabled)
	
	if (READ_PROPERTY)
		GB.ReturnBoolean(CLTIMER->is_enabled ());
	
	else
	{
		if (VPROP(GB_BOOLEAN))
			CLTIMER->enable ();
		else
			CLTIMER->disable ();
	}
	
END_PROPERTY

/**************************************************************************/

GB_DESC CLtimer[] =
{
	GB_DECLARE("Timer", sizeof(CTIMER)),

	GB_EVENT("Timer", NULL, NULL, &EVENT_timer),

	GB_METHOD("_new", NULL, CLTIMER_new, NULL),
	GB_METHOD("_free", NULL, CLTIMER_free, NULL),

	GB_PROPERTY("Delay", "i", CLTIMER_delay),
	GB_PROPERTY("Enabled", "b", CLTIMER_Enabled),

	GB_END_DECLARE
};

myTimer::myTimer (CTIMER *timer)
{
	this->_timer = timer;
	myTimer_slot = sig_timer().connect(this, &myTimer::callback);
}

void myTimer::callback (void)
{
	if (GB.CanRaise(_timer, EVENT_timer))
		GB.Raise(_timer, EVENT_timer, 0);
}
