/***************************************************************************

  CScreen.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  GTK+ component
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CSCREEN_CPP

#include <stdio.h>
#include "gambas.h"
#include "main.h"
#include "widgets.h"
#include "CScreen.h"
#include "CWindow.h"
#include "CPicture.h"


BEGIN_PROPERTY(CSCREEN_width)

	GB.ReturnInteger(gDesktop::width());

END_PROPERTY


BEGIN_PROPERTY(CSCREEN_height)

	GB.ReturnInteger(gDesktop::height());

END_PROPERTY


BEGIN_PROPERTY(CSCREEN_resolution)

	GB.ReturnInteger(gDesktop::resolution());

END_PROPERTY

BEGIN_PROPERTY(CSCREEN_charset)

  GB.ReturnConstZeroString("UTF-8");

END_PROPERTY


BEGIN_METHOD_VOID(CSCREEN_grab)

	CPICTURE *pic=NULL;
	gPicture *buf=gDesktop::grab();
  
	GB.New((void **)&pic, GB.FindClass("Picture"), 0, 0);
	if (pic->picture) delete pic->picture;
	pic->picture=buf;
	GB.ReturnObject(pic);

END_METHOD

BEGIN_PROPERTY(CSCREEN_font)

  stub ("CSCREEN_font");

END_PROPERTY


BEGIN_PROPERTY(CSCREEN_active_window)

  stub ("CSCREEN_active_window");

END_PROPERTY


BEGIN_PROPERTY(CSCREEN_busy)

  stub ("CSCREEN_busy");

END_PROPERTY



BEGIN_PROPERTY(CAPP_tooltip_enabled)

  stub ("CAPP_tooltip_enabled");
  if (READ_PROPERTY) { GB.ReturnBoolean(false); return; }
    //GB.ReturnBoolean(QToolTip::isGloballyEnabled());


END_PROPERTY


BEGIN_PROPERTY(CAPP_tooltip_font)

  stub ("CAPP_tooltip_font");
  if (READ_PROPERTY) { GB.ReturnBoolean(false); return; }

  
END_PROPERTY


BEGIN_PROPERTY(CAPP_main_window)

  GB.ReturnObject(WINDOW_get_main());

END_PROPERTY




GB_DESC CDesktopDesc[] =
{
  GB_DECLARE("Desktop", 0), GB_VIRTUAL_CLASS(),

  GB_STATIC_PROPERTY_READ("W", "i", CSCREEN_width),
  GB_STATIC_PROPERTY_READ("H", "i", CSCREEN_height),
  GB_STATIC_PROPERTY_READ("Width", "i", CSCREEN_width),
  GB_STATIC_PROPERTY_READ("Height", "i", CSCREEN_height),
  GB_STATIC_PROPERTY_READ("Charset", "s", CSCREEN_charset),
  GB_STATIC_PROPERTY_READ("Resolution", "i", CSCREEN_resolution),

  GB_STATIC_METHOD("Grab", "Picture", CSCREEN_grab, NULL),

  GB_END_DECLARE
};

GB_DESC CApplicationTooltipDesc[] =
{
  GB_DECLARE(".ApplicationTooltip", 0), GB_VIRTUAL_CLASS(),

  GB_STATIC_PROPERTY("Enabled", "b", CAPP_tooltip_enabled),
  GB_STATIC_PROPERTY("Font", "Font", CAPP_tooltip_font),

  GB_END_DECLARE
};



GB_DESC CApplicationDesc[] =
{
  GB_DECLARE("Application", 0), GB_VIRTUAL_CLASS(),

  GB_STATIC_PROPERTY("Font", "Font", CSCREEN_font),
  GB_STATIC_PROPERTY_READ("ActiveWindow", "o", CSCREEN_active_window),
  GB_STATIC_PROPERTY_READ("MainWindow", "o", CAPP_main_window),
  GB_STATIC_PROPERTY("Busy", "i", CSCREEN_busy),
  GB_STATIC_PROPERTY_SELF("ToolTip", ".ApplicationTooltip"),

  GB_END_DECLARE
};


