/***************************************************************************

  CTimer.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  GTK+ component
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CTIMER_CPP

#include <stdio.h>
#include "gambas.h"
#include "main.h"
#include "widgets.h"
#include "CTimer.h"
#include "CWindow.h"

GB_CLASS CLASS_Timer=NULL;

DECLARE_EVENT(EVENT_Timer);

void gb_raise_timer(void *_ob)
{
	if (GB.CanRaise(_ob,EVENT_Timer)) 
		GB.Raise(_ob,EVENT_Timer,0);
	else
		((CTIMER*)_ob)->timer->setEnabled(false);
}



BEGIN_METHOD_VOID(CTIMER_new)

	if (!CLASS_Timer) CLASS_Timer=GB.FindClass("Timer");
	TIMER=new gTimer();
	TIMER->data=THIS;
	TIMER->onTimer=gb_raise_timer;
	
END_METHOD


BEGIN_METHOD_VOID(CTIMER_free)

	TIMER->setEnabled(false);
	delete TIMER;

END_METHOD


BEGIN_PROPERTY(CTIMER_delay)

	if (READ_PROPERTY) { GB.ReturnInteger(TIMER->delay()); return; }
	TIMER->setDelay(VPROP(GB_INTEGER));

END_PROPERTY


BEGIN_PROPERTY(CTIMER_enabled)

	if (READ_PROPERTY) { GB.ReturnBoolean(TIMER->enabled()); return; }
	TIMER->setEnabled(VPROP(GB_BOOLEAN));

END_PROPERTY


GB_DESC CTimerDesc[] =
{
  GB_DECLARE("Timer", sizeof(CTIMER)),

  GB_METHOD("_new", NULL, CTIMER_new, NULL), 
  GB_METHOD("_free", NULL, CTIMER_free, NULL),

  GB_PROPERTY("Enabled", "b", CTIMER_enabled),
  GB_PROPERTY("Delay", "i", CTIMER_delay),

  GB_CONSTANT("_Properties", "s", CTIMER_PROPERTIES),
  GB_CONSTANT("_DefaultEvent", "s", "Timer"),

  GB_EVENT("Timer", NULL, NULL, &EVENT_Timer),

  GB_END_DECLARE
};


