/***************************************************************************

  CWindow.h

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  GTK+ component
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __CWINDOW_H
#define __CWINDOW_H


#include "gambas.h"
#include "main.h"
#include "widgets.h"
#include "CWidget.h"

#ifndef __CWINDOW_CPP

extern GB_DESC CWindowMenusDesc[];
extern GB_DESC CWindowDesc[];
extern GB_DESC CWindowsDesc[];
extern GB_DESC CFormDesc[];

#else

#define THIS ((CWINDOW *)_object)
#define WINDOW ((gMainWindow*)(THIS->widget))
#define CWINDOW_PROPERTIES CWIDGET_PROPERTIES \
  ",Text,Icon,Mask,Persistent,Border,State,TopOnly,SkipTaskbar,Arrangement,Spacing,Padding"
  
#endif

typedef  struct
{
    GB_BASE ob;
    gControl *widget;
	GB_VARIANT_VALUE tag;
	
	long ret;
	unsigned persistent : 1;
	unsigned modal : 1;

}  CWINDOW;

typedef  struct 
{
    CWINDOW window;

}  CFORM;


#endif

CWINDOW* WINDOW_get_main();
void WINDOW_kill(CWINDOW *win);

