/***************************************************************************

  gbutton.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  Gtkmae "GTK+ made easy" classes
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#include <stdio.h>

#include <gtk/gtk.h>
#include <string.h>
#include <stdlib.h>
#include "widgets.h"
#include "widgets_private.h"

void bt_click (GtkButton *object,gControl *data)
{

	if (((gButton*)data)->type==4)
	{
		if ( ((gButton*)data)->disable )
		{
			((gButton*)data)->disable=false;
			return;
		}
		if (!((gButton*)data)->isToggle)
		{
			((gButton*)data)->disable=true;
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(data->widget),false);
		}
	}

	if (((gButton*)data)->onClick) ((gButton*)data)->onClick((gControl*)data);
	return;
}

void rd_click (GtkButton *object,gControl *data)
{
	if (gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(object)))
		if (((gButton*)data)->onClick) ((gButton*)data)->onClick((gControl*)data);
	return;
}


//***************************************************************
// Type:
// 0 -> Button
// 1 -> ToggleButton
// 2 -> CheckBox
// 3 -> RadioButton
// 4 -> ToolButton
//***************************************************************
gButton::gButton(gControl *parent,int typ) : gControl(parent)
{
	PangoLayout *ly;
	PangoContext *cti;
	PangoMatrix mtr=PANGO_MATRIX_INIT;
	GtkHBox *box;
	GtkWidget *lbl;	
	GtkWidget *img;
	gContainer *ct;
	
	isToggle=false;
	disable=false;
	g_typ=Type_gButton;
	bufText=NULL;
	border=gtk_event_box_new();
	scaled=false;
	
	switch(typ)
	{
		case 1:
			widget=gtk_toggle_button_new();
			type=1;
			break;
			
		case 2:
			widget=gtk_check_button_new();
			type=2;
			break;
		case 3:
			ct=(gContainer*)pr;
			if (!ct->radiogroup) 
			{
				ct->radiogroup=gtk_radio_button_new(NULL);
				g_object_ref(ct->radiogroup);
				widget=gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(ct->radiogroup));
				gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(widget),true);
			}
			else 
			{
				widget=gtk_radio_button_new_from_widget(GTK_RADIO_BUTTON(ct->radiogroup));
			}
			type=3;
			break;
		case 4:
			widget=gtk_toggle_button_new();
			type=4;
			break;
		
		default:
			widget=gtk_button_new();
			type=0;
			break;
	}
	
	gtk_container_add (GTK_CONTAINER(border),widget);	
	box=(GtkHBox*)gtk_hbox_new(false,0);
			
	img=gtk_image_new_from_pixbuf(NULL);
	gtk_box_pack_start(GTK_BOX(box),img,true,false,0);
	if (type != 4)
	{
		lbl=gtk_label_new_with_mnemonic("");
		gtk_box_pack_start(GTK_BOX(box),lbl,true,false,0);
		ly=gtk_label_get_layout(GTK_LABEL(lbl));
		cti=pango_layout_get_context(ly);
		pango_context_set_matrix(cti,&mtr);
	}
	
	gtk_container_add (GTK_CONTAINER(widget),GTK_WIDGET(box));
	gtk_button_set_focus_on_click (GTK_BUTTON(widget),true);
	gtk_widget_add_events(widget,GDK_POINTER_MOTION_MASK);
	
	onClick=NULL;
	
	connectParent();
	initSignals();
	
	if (type==3)
		g_signal_connect(G_OBJECT(widget),"clicked",G_CALLBACK(rd_click),(gpointer)this);
	else
		g_signal_connect(G_OBJECT(widget),"clicked",G_CALLBACK(bt_click),(gpointer)this);	
	
	resize(100,30);
	if (type==4) setBorder(false);
	g_object_set(G_OBJECT(img),"visible",false,NULL);
	
}

void gButton::setFont(gFont *ft)
{
	PangoFontDescription *desc=pango_context_get_font_description(ft->ct);
	GtkHBox *box;
	GtkLabel *lbl;
	GList *chd;
	
	if (type==4) { gtk_widget_modify_font(widget,desc); return; }
	
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	chd=chd->next;
	lbl=GTK_LABEL(chd->data);
	gtk_widget_modify_font(GTK_WIDGET(lbl),desc);
	g_list_free(chd);
	performScale();
}

gFont* gButton::font()
{
	GtkHBox *box;
	GtkLabel *lbl;
	GList *chd;
	gFont *hFont;

	if (type==4) return new gFont(widget);
	
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	chd=chd->next;
	lbl=GTK_LABEL(chd->data);
	hFont=new gFont(GTK_WIDGET(lbl));
	g_list_free(chd);
	return hFont;
	
	
}

void gButton::performScale()
{
	PangoLayout *ly;
	PangoContext *cti;
	PangoMatrix *mtr;
	GtkHBox *box;
	GtkLabel *lbl;
	GList *chd;
	int ph;

	if (type == 4) return;

	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	chd=chd->next;
	lbl=GTK_LABEL(chd->data);
	ly=gtk_label_get_layout(lbl);
	pango_layout_get_size(ly,NULL,&ph);
	ph/=PANGO_SCALE;
	cti=pango_layout_get_context(ly);
	mtr=(PangoMatrix*)pango_context_get_matrix(cti);
	
	if (ph>=(height()-11))
	{
		if (!scaled) { 
			scaled=true;
			pango_matrix_scale(mtr,0.9,0.78);
		}
	}
	else
	{
		if (scaled) {
			scaled=false;
			pango_matrix_scale(mtr,1/0.9,1/0.78);
		}
	}

	g_list_free(chd);
}

void gButton::resize(long w,long h)
{
	if (w<1) w=1;
	if (h<1) h=1;	
	
	if ( (this->bufW==w) && (this->bufH==h) ) return;

	this->bufW=w;
	this->bufH=h;
	
	gtk_widget_set_size_request(border,w,h);
	
	performScale();
		
	((gContainer*)parent())->performArrange();

	
		
	
	//ngoMatrix mtr=PANGO_MATRIX_INIT;

	//pango_matrix_scale (&mtr, 0.8,0.8);
	//pango_context_set_matrix(cti,&mtr);
	
}

void gButton::setBackGround(long color)
{
	GtkWidget *wid;

	wid=(type==2)? border:widget;
	set_gdk_bg_color(wid,color);
	if (!border->window) gtk_widget_realize(border);
	gdk_window_process_updates(border->window,true);
}

long gButton::backGround()
{
	if (type==2) get_gdk_bg_color(border);
	return get_gdk_bg_color(widget);
}

void gButton::setForeGround(long color)
{
	GList *chd;
	GtkHBox *box;
	
	set_gdk_fg_color(widget,color);
	
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	while (chd)
	{
		set_gdk_fg_color(GTK_WIDGET(chd->data),color);
		chd=g_list_next(chd);
		
	}
	
	if (!border->window) gtk_widget_realize(border);
	gdk_window_process_updates(border->window,true);
}

long gButton::foreGround()
{
	return get_gdk_fg_color(widget);
}


const char* gButton::text()
{
	if (type==4) return this->toolTip();
	return bufText;
}

void gMnemonic_correctText(char *st,char **buf)
{
	long bucle,b2;
	long len=strlen(st);
	long len_in=len;
	
	for (bucle=0;bucle<len_in;bucle++)
	{
		if (st[bucle]=='&')
		{
			if (bucle<(len_in-1)) 
				if (st[bucle+1]=='&')
					len--;
				
		}
		else if (st[bucle]=='_') len++;
	}
	
	*buf=(char*)malloc(sizeof(char)*(len+1));
	b2=0;
	
	for (bucle=0;bucle<len_in;bucle++)
	{
		if (st[bucle]=='&')
		{
			if (bucle<(len_in-1))
			{
				if (st[bucle+1]=='&')
				{
					(*buf)[b2++]='&';
					bucle++;
				}
				else
				{
					(*buf)[b2++]='_';
				}
			}
			else
			{
				(*buf)[b2]=' ';
				b2++;
			}
		}
		else if (st[bucle]=='_')
		{
			(*buf)[b2++]='_';
			(*buf)[b2++]='_';
		}
		else
		{
			(*buf)[b2++]=st[bucle];
		}	
		(*buf)[b2]=0;
	}
}

void gButton::setText(const char *st)
{
	GList *chd;
	GtkLabel *lbl=NULL;
	GtkHBox *box;
	char *buf=NULL;
	
	if (type==4) { this->setToolTip((char*)st); return; }
	
	if (bufText) g_free(bufText);
	bufText=g_strdup(st);
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));

	chd=chd->next;
	lbl=GTK_LABEL(chd->data);
		
	if (!st)
	{ 
		gtk_label_set_text(lbl,"");
		g_object_set(G_OBJECT(lbl),"visible",false,NULL);
		g_list_free(chd);
		return;
	}
	
	if (!strlen(st))
	{ 
		gtk_label_set_text(lbl,"");
		g_object_set(G_OBJECT(lbl),"visible",false,NULL);
		g_list_free(chd);
		return;
	}
	
	gMnemonic_correctText((char*)st,&buf);
	gtk_label_set_text_with_mnemonic(lbl,buf);
	g_object_set(G_OBJECT(lbl),"visible",true,NULL);
	g_list_free(chd);
	free(buf);
	performScale();
}


gPicture* gButton::picture()
{
	GdkPixbuf *buf=NULL;
	GList *chd;
	GtkHBox *box;	
	gPicture *pic;
	GdkScreen *scr;
	gint depth;
	gint myw,myh;
	
	if ( (type==2) || (type==3) ) return NULL;
	
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	chd=g_list_first(chd);
	
	buf=gtk_image_get_pixbuf(GTK_IMAGE(chd->data));
	pic=gPicture::fromPixbuf(buf);
	g_list_free(chd);
	
	return pic;
	
}

void gButton::setPicture(gPicture *pic)
{
	GtkImage *img;
	GdkPixbuf *buf=NULL;
	GList *chd;
	GtkHBox *box;
	
	if ( (type==2) || (type==3) ) return;
	
	if (!pic) buf=NULL;
	else      buf=pic->getPixbuf();
	
	box=(GtkHBox*)gtk_bin_get_child(GTK_BIN(widget));
	chd=gtk_container_get_children(GTK_CONTAINER(box));
	chd=g_list_first(chd);
	
	gtk_image_set_from_pixbuf(GTK_IMAGE(chd->data),buf);
	if (!buf) g_object_set(G_OBJECT(chd->data),"visible",false,NULL);
	else g_object_set(G_OBJECT(chd->data),"visible",true,NULL);
	
	g_list_free(chd);
	
}

bool gButton::_border()
{
	switch(gtk_button_get_relief(GTK_BUTTON(widget)))
	{
		case GTK_RELIEF_NORMAL:
		case GTK_RELIEF_HALF:
			return true;
		default: 
			return false;
	}
}

void gButton::setBorder(bool vl)
{
	if (vl)
		gtk_button_set_relief (GTK_BUTTON(widget),GTK_RELIEF_NORMAL);
	else
		gtk_button_set_relief (GTK_BUTTON(widget),GTK_RELIEF_NONE);
}

bool gButton::isDefault()
{
	if (GTK_WIDGET_HAS_DEFAULT(widget)) return true;
	
	return false;
}

void gButton::setDefault(bool vl)
{
	if (vl)
	{
		GTK_WIDGET_SET_FLAGS (widget, GTK_CAN_DEFAULT);
		GTK_WIDGET_SET_FLAGS (widget, GTK_CAN_FOCUS);
		gtk_widget_grab_focus (widget);
		gtk_widget_grab_default (widget);
	}
	else
	{
		GTK_WIDGET_UNSET_FLAGS (widget, GTK_CAN_DEFAULT);
		GTK_WIDGET_UNSET_FLAGS (widget, GTK_CAN_FOCUS);
	}
}

bool gButton::value()
{
	switch(type)
	{
		case 1:
		case 2:
		case 3:
		case 4:
			return gtk_toggle_button_get_active (GTK_TOGGLE_BUTTON(widget));
		
		default:
			return false;
	}
		
}

void gButton::setValue(bool vl)
{
	switch(type)
	{
		case 1:
		case 2:
		case 3:
		case 4:
			gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON(widget),vl);
			break;
		
		default:
			if (vl) gtk_button_clicked(GTK_BUTTON(widget));
			break;
	}
}

bool gButton::isCancel()
{
	gControl *par=this->pr;
	
	if (type!=0) return false;
	
	while (par->pr) par=par->pr;
	if (((gMainWindow*)par)->esc_button==widget) return true;
	return false;
}

void gButton::setCancel(bool vl)
{
	gControl *par=this->pr;
	
	if (type!=0) return;
	
	while (par->pr) par=par->pr;
	((gMainWindow*)par)->esc_button=widget;
	
}

bool gButton::getToggle()
{
	if (type!=4) return false;
	return isToggle;
}

void gButton::setToggle(bool vl)
{
	if (type!=4) return;
	isToggle=vl;
}

