/***************************************************************************

  gframe.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  Gtkmae "GTK+ made easy" classes
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#include "widgets.h"
#include "widgets_private.h"
#include <stdio.h>
#include <string.h>

void frame_show (GtkWidget *widget, gFrame *data)
{
	data->performArrange();
}

gFrame::gFrame(gControl *parent,bool title) : gContainer(parent)
{
	GtkWidget* fr;
	GtkWidget *lbl=NULL;
	
	g_typ=Type_gFrame;
	
	border=gtk_event_box_new();
	fr=gtk_frame_new("");
	gtk_frame_set_shadow_type(GTK_FRAME(fr),GTK_SHADOW_OUT);
	if (title)
	{
		lbl=gtk_label_new("");
		gtk_label_set_use_markup(GTK_LABEL(lbl),false);
		gtk_frame_set_label_widget(GTK_FRAME(fr),lbl);
		offY=18;
	}
	else
		gtk_frame_set_label_widget(GTK_FRAME(fr),NULL);
	
	widget=gtk_layout_new(0,0);
	gtk_container_add(GTK_CONTAINER(fr),widget);
	gtk_container_add(GTK_CONTAINER(border),fr);
	connectParent();
	initSignals();
	g_signal_connect(G_OBJECT(border),"show",G_CALLBACK(frame_show),(gpointer)this);
}

long gFrame::foreGround()
{
	return get_gdk_fg_color(widget);
}

void gFrame::setForeGround(long color)
{	
	GtkWidget *lbl;
	
	lbl=gtk_frame_get_label_widget(GTK_FRAME(widget->parent));
	if (lbl) set_gdk_fg_color(lbl,color);
	set_gdk_fg_color(widget,color);
	if (!border->window) gtk_widget_realize(border);
	gdk_window_process_updates(border->window,true);
}

long gFrame::backGround()
{
	return get_gdk_bg_color(border);
}

void gFrame::setBackGround(long color)
{	
	GtkWidget *lbl;
	
	set_gdk_bg_color(border,color);
	set_gdk_bg_color(widget,color);
	if (!border->window) gtk_widget_realize(border);
	gdk_window_process_updates(border->window,true);
}
		
char* gFrame::text()
{
	GtkWidget *lbl;
	
	lbl=gtk_frame_get_label_widget(GTK_FRAME(widget->parent));
	if (!lbl) return NULL;
	return (char*)gtk_label_get_text(GTK_LABEL(lbl));
}

void gFrame::setText(char *vl)
{
	GtkWidget *lbl;
	bool erase=false;
	
	if (!vl) erase=true;
	else if (!strlen(vl)) erase=true;
	
	if (erase)
	{
		gtk_frame_set_label_widget(GTK_FRAME(widget->parent),NULL);
		return;
	}
	
	lbl=gtk_frame_get_label_widget(GTK_FRAME(widget->parent));
	if (!lbl)
	{
		lbl=gtk_label_new("");
		gtk_label_set_use_markup(GTK_LABEL(lbl),false);
		gtk_frame_set_label_widget(GTK_FRAME(widget->parent),lbl);
		set_gdk_fg_color(lbl,get_gdk_fg_color(widget));
		gtk_widget_show(lbl);
	}
	gtk_label_set_text(GTK_LABEL(lbl),vl);
}

int gFrame::getBorder()
{
	return Frame_getBorder(GTK_FRAME(widget->parent));
}

void gFrame::setBorder(int vl)
{
	Frame_setBorder(GTK_FRAME(widget->parent),vl);
}
