/***************************************************************************

  glabel.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  Gtkmae "GTK+ made easy" classes
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#include <gtk/gtk.h>
#include "widgets.h"
#include "widgets_private.h"


void gLabel::fontModified()
{

	return;
	PangoAttrList *pal=pango_attr_list_new();
	PangoAttribute *pa=pango_attr_strikethrough_new(true);
	pa->start_index = 0;
	pa->end_index = g_utf8_strlen(gtk_label_get_text(GTK_LABEL(widget)), -1); 
	pango_attr_list_insert(pal, pa);
	gtk_label_set_attributes(GTK_LABEL(widget), pal);
	pango_attr_list_unref(pal);
}

gLabel::gLabel(gControl *parent) : gControl(parent)
{
	GtkWidget *fr;	

	g_typ=Type_gLabel;
	border=gtk_event_box_new();
	widget=gtk_label_new("");
	fr=gtk_frame_new("");
	gtk_frame_set_shadow_type(GTK_FRAME(fr),GTK_SHADOW_NONE);
	gtk_frame_set_label_widget(GTK_FRAME(fr),NULL);
	//gtk_label_set_single_line_mode (GTK_LABEL(widget),false);
	gtk_label_set_line_wrap (GTK_LABEL(widget),true);
	gtk_label_set_justify(GTK_LABEL(widget),GTK_JUSTIFY_CENTER);
	gtk_label_set_use_markup (GTK_LABEL(widget),false);
	gtk_container_add (GTK_CONTAINER(fr),widget);
	gtk_container_add (GTK_CONTAINER(border),fr);	
	connectParent();
	initSignals();
	setAlignment(alignNormal);
	
}

gTextLabel::gTextLabel(gControl *parent) : gLabel(parent)
{
	g_typ=Type_gTextLabel;
	gtk_label_set_use_markup (GTK_LABEL(widget),true);
	setAlignment(alignTopNormal);
}

int gLabel::alignment()
{
	gfloat x,y;
	int retval=0;
	
	gtk_misc_get_alignment (GTK_MISC(widget),&x,&y);

	if (!x) retval+=1; 
	else if (x==1) retval+=2; 
	
	if (!y) retval+=16; 
	else if (y==1) retval+=32;
	else retval+=64;
	
	return retval;
}

const char* gLabel::text()
{
	return gtk_label_get_text(GTK_LABEL(widget));
}

const char* gTextLabel::text()
{
	return gtk_label_get_text(GTK_LABEL(widget));
}

void gLabel::setAlignment(int al)
{
	gfloat x,y;
		
	switch (al)
	{
		case alignBottom: 	y=1; 	x=0.5; break;
		case alignBottomLeft: 	y=1; 	x=0; break;
		case alignBottomNormal: y=1; 	x=0; break;
		case alignBottomRight: 	y=1; 	x=1; break;
		case alignCenter: 	y=0.5; 	x=0.5; break;
		case alignLeft: 	y=0.5; 	x=0; break;
		case alignNormal: 	y=0.5;  x=0; break;
		case alignRight: 	y=0.5; 	x=1; break;
		case alignTop: 		y=0; 	x=0.5; break;
		case alignTopLeft: 	y=0; 	x=0; break;
		case alignTopNormal: 	y=0; 	x=0; break;
		case alignTopRight: 	y=0; 	x=1; break;
		default: return;
	}
	
	gtk_misc_set_alignment(GTK_MISC(widget),x,y);
}

void gLabel::setText(const char *st)
{
	gtk_label_set_text(GTK_LABEL(widget),st);
	//fontModified();
}

void gTextLabel::setText(const char *st)
{
	gtk_label_set_markup(GTK_LABEL(widget),st);
	//fontModified();

}

int gLabel::getBorder()
{
	return Frame_getBorder(GTK_FRAME(widget->parent));
}

void gLabel::setBorder(int vl)
{
	Frame_setBorder(GTK_FRAME(widget->parent),vl);
}

