/***************************************************************************

  gtimer.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  Gtkmae "GTK+ made easy" classes
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#include "widgets.h"
#include <gtk/gtk.h>
	
#include <stdio.h>
gboolean g_timer_time(gTimer *ob)
{
	if (ob->onTimer) ob->onTimer(ob->data);
	return true;
}

gTimer::gTimer()
{
	val=false;
	data=NULL;
	onTimer=NULL;
	timer=-1;
}

gTimer::~gTimer()
{
	setEnabled(false);
}
	
long gTimer::delay()
{
	return interval;
}

bool gTimer::enabled()
{
	if (timer==-1) return false;
	return true;
}

void gTimer::setDelay(long vl)
{
	interval=vl;
	if (val) { 
		setEnabled(false);
		setEnabled(true);
	}
	
}

void gTimer::setEnabled(bool vl)
{
	val=vl;
	
	if (vl)	
	{
		if (timer==-1)
		{
			if (interval>0)
			{
				timer=g_timeout_add(interval,(GSourceFunc)g_timer_time,(gpointer)this);
				g_source_set_can_recurse(g_main_context_find_source_by_id(NULL,timer),true);
			}
		}
	}
	else
	{
		if (timer!=-1)
		{
			g_source_remove(timer);
			timer=-1;
		}	
	}
}

