/***************************************************************************

  main.cpp

  (c) 2004-2005 - Daniel Campos Fernández <danielcampos@netcourrier.com>
  
  GTK+ component
  
  Realizado para la Junta de Extremadura. 
  Consejería de Educación Ciencia y Tecnología. 
  Proyecto gnuLinEx
  
  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __MAIN_C

#include <stdio.h>

#include "gambas.h"
#include "main.h"
#include "widgets.h"
#include "watcher.h"

#include "CTimer.h"
#include "CScreen.h"
#include "CDraw.h"
#include "CConst.h"
#include "CColor.h"
#include "CFont.h"
#include "CKey.h"
#include "CImage.h"
#include "CPicture.h"
#include "CClipboard.h"
#include "CMouse.h"
#include "CMessage.h"
#include "CDialog.h"
#include "CWidget.h"
#include "CProgress.h"
#include "CDrawingArea.h"
#include "CContainer.h"
#include "CFrame.h"
#include "CMenu.h"
#include "CWindow.h"
#include "CLabel.h"
#include "CButton.h"
#include "CPictureBox.h"
#include "CTextBox.h"
#include "CTextArea.h"
#include "CListBox.h"
#include "CListView.h"
#include "CColumnView.h"
#include "CSlider.h"
#include "CTabStrip.h"
#include "CTrayIcon.h"
#include "CScrollView.h"
#include "CSpinBox.h"

#include <gtk/gtk.h>

static void my_quit (void);
static void my_main(int *argc, char **argv);
static void my_wait(long duration);
static void my_post(void);
static int my_loop();
static void my_watch(int fd, int type, void *callback, long param);
bool post_Check=false;




extern "C" 
{

	GB_INTERFACE GB;


	GB_DESC *GB_CLASSES[] =
	{
		CTimerDesc,
		CDesktopDesc,
		CApplicationTooltipDesc,
		CApplicationDesc,
		CAlignDesc,
		CArrangeDesc,
		CBorderDesc,
		CScrollDesc,
		CLineDesc,
		CFillDesc,
		CColorDesc,
		CFontsDesc,
		CFontDesc,
		CKeyDesc,
		CDrawDesc,
		CDrawClipDesc,
		CImageDesc,
		CPictureDesc,
		CClipboardDesc,
		CDragDesc,
		CCursorDesc,
		CMouseDesc,
		CMessageDesc,
		CDialogDesc,
		CWidgetDesc,
		CChildrenDesc,
		CContainerDesc,
		CDrawingAreaDesc,
		CFrameDesc,
		CPanelDesc,
		CHBoxDesc,
		CVBoxDesc,
		CHPanelDesc,
		CVPanelDesc,
		CMenuDesc,
		CMenuChildrenDesc,
		CTrayIconDesc,
		CTrayIconsDesc,
		CWindowMenusDesc,
		CWindowDesc,
		CWindowsDesc,
		CFormDesc,
		CProgressDesc,
		CLabelDesc,
		CTextViewDesc,
		CSliderDesc,
		CScrollBarDesc,
		CButtonDesc,
		CToggleButtonDesc,
		CCheckBoxDesc,
		CRadioButtonDesc,
		CToolButtonDesc,
		CPictureBoxDesc,
		CMovieBoxDesc,
		CListBoxDesc,
		CListBoxItemDesc,
		CTextBoxSelectionDesc,
		CTextBoxDesc,
		CTextAreaDesc,
		CTextAreaSelectionDesc,
		CComboBoxDesc,
		CComboBoxItemDesc,
		CListViewItemDesc,
		CListViewDesc,
		CColumnViewItemDesc,
		CColumnViewColumnDesc,
		CColumnViewColumnsDesc,
		CColumnViewDesc,
		CTabStripDesc,
		CTabDesc,
		CTabChildrenDesc,
		CPluginDesc,
		CScrollViewDesc,
		CSpinBoxDesc,
		
		NULL
	};

	int GB_INIT(void)
	{
		CWatcher::Init();
		gMessage::setTitle(GB.Application.Name());
		GB.Hook(GB_HOOK_QUIT, (void *)my_quit);
		GB.Hook(GB_HOOK_MAIN, (void *)my_main);
		GB.Hook(GB_HOOK_WAIT, (void *)my_wait);
		GB.Hook(GB_HOOK_LOOP, (void *)my_loop);
		GB.Hook(GB_HOOK_WATCH,(void *)my_watch);
		GB.Hook(GB_HOOK_POST,(void*)my_post);
		return FALSE;
	}

	void GB_EXIT()
	{
		CWatcher::Clear();
		gMessage::setTitle(NULL);
		gDialog::setPath(NULL);
		gDialog::setFilter(NULL,0);
	}



}

void my_quit (void)
{
	CWINDOW *win=WINDOW_get_main();
	
	gApplication::suspendEvents(true);
	if (win) 
	{
		if (win->widget) ((gMainWindow*)win->widget)->destroy();
		//WINDOW_kill(win);
		//delete (gMainWindow*)win->widget;
		while (gtk_events_pending ())
		{
	  		gtk_main_iteration_do (false);
		}
		//
	}
	
}

static void my_main(int *argc, char **argv)
{
	gApplication::init(argc,&argv);
}

static void my_post(void)
{
	post_Check=true;
}

static int my_loop()
{
	while (1) 
	{ 
		do_iteration(); 
		if (!WINDOW_get_main()) return 0; 
	}
}

static void my_wait(long duration)
{
	do_iteration();   
}

static void my_watch(int fd, int type, void *callback, long param)
{
	CWatcher::Add(fd,type,callback,param);
}

void do_iteration(void)
{
	if (post_Check) { post_Check=false; GB.CheckPost(); }
	CWatcher::Perform();
	gApplication::iteration();
}


