/***************************************************************************

  driver.c

  Gambas extension using SDL

  (c) 2004-2005 Laurent Carlier <lordheavy@infonie.fr>
                Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __DRIVER_C

#include <stdlib.h>

#include "gambas.h"
#include "main.h"

#include "driver.h"
#include "SDL.h"

/* fill the videoinfo struct before opening a videomode (grab best video values) */

void DRIVERINFO_init(void)
{
  DriverInfo = SDL_GetVideoInfo();
}

BEGIN_PROPERTY(DRIVERINFO_driver)

  char driver[20];

  if (SDL_VideoDriverName((char *) driver, sizeof(driver)))
    GB.ReturnNewZeroString((char *) &driver);
  else
    GB.Error("DRIVERINFO_driver, SDL error ! : &1", SDL_GetError());
  return;

END_PROPERTY

/* available video memory */

BEGIN_PROPERTY(DRIVERINFO_videomem)

  GB.ReturnInteger((int ) DriverInfo->video_mem);

END_PROPERTY

/* best pixel depth available */

BEGIN_PROPERTY(DRIVERINFO_bestpixeldepth)

  GB.ReturnInteger((int ) DriverInfo->vfmt->BitsPerPixel);

END_PROPERTY

BEGIN_PROPERTY(DRIVERINFO_accelerated)

  GB.ReturnBoolean((int ) DriverInfo->hw_available);

END_PROPERTY

BEGIN_PROPERTY(DRIVERINFO_wmanager)

  GB.ReturnBoolean((int ) DriverInfo->wm_available);

END_PROPERTY

/***************************************************************************

  Dclarations

***************************************************************************/

GB_DESC Cdriverinfo[] =
{
  GB_DECLARE("DriverInfo",0), GB_NOT_CREATABLE(),

  GB_STATIC_PROPERTY_READ("Name",           "s", DRIVERINFO_driver),
  GB_STATIC_PROPERTY_READ("Memory",         "i", DRIVERINFO_videomem),
  GB_STATIC_PROPERTY_READ("BestPixelDepth", "i", DRIVERINFO_bestpixeldepth),
  GB_STATIC_PROPERTY_READ("Accelerated",    "b", DRIVERINFO_accelerated),
  GB_STATIC_PROPERTY_READ("WindowManager",  "b", DRIVERINFO_wmanager),

  GB_END_DECLARE
};
