/***************************************************************************

  font.h

  The SDL component

  Font management

  (c) 2004-2005 Laurent Carlier <lordheavy@infonie.fr>
                Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __FONT_H
#define __FONT_H

#include "gambas.h"

#include "SDL.h"

/* SFont includes */
#include "SFont.h"

/* TTFont include */
#include "SDL_ttf.h"

#define FONT_TTF   1
#define FONT_SFONT 2

typedef
  struct {
    GB_BASE ob;
    void *id;
    int fontType;
    char *fontName;
    int quality;
    }
  CFONT;

#ifndef __FONT_C
extern GB_DESC Cfont[];
#else

#define THIS     ((CFONT *)_object)
#define FONTNAME ((CFONT *)_object)->fontName
#define FONTTYPE ((CFONT *)_object)->fontType
#define FONTQUAL ((CFONT *)_object)->quality
#define FONTID   ((CFONT *)_object)->id

#endif /* __FONT_C */

#endif /* __FONT_H */
