/***************************************************************************

  main.h

  The SDL component

  (c) 2004-2005 Laurent Carlier <lordheavy@infonie.fr>
                Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __MAIN_H
#define __MAIN_H

#include "gambas.h"
#include "../gb.sdl.h"

#include "SDL.h"

typedef
  struct {
    SDL_Surface *id;            /* id of the main screen */
    char *Wname;                /* name of the window (only with of WM of course !) */
    float Gred, Ggreen, Gblue;  /* the gamma value of the screen (only in fullscreen */
    int fullscreen;             /* fullscreen mode (only with a WM) */
    int WantQuit;               /* Want to quit */
    int RetVal;
  }
  Mscreen;

#ifndef __MAIN_C
extern GB_INTERFACE GB;
extern SDL_INTERFACE SDL;
extern const SDL_VideoInfo *DriverInfo;
extern Mscreen *mScreen;
#endif /* __MAIN_C */

#define MainScreen mScreen->id

#endif /* __MAIN_H */
