 /***************************************************************************

  gb.sdl.h

  Gambas extension using SDL

  (c) 2004, 2005 Laurent Carlier <lordheavy@infonie.fr>
                 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __MAIN_C

#include "main.h"
#include "gb_common.h"

#include "gb.sdl.h"
#include "cdrom.h"

#include "SDL.h"


GB_INTERFACE GB;

int sdlInit_count = 0;

int Init(Uint32 flags)
{
  Uint32 myflags = 0;
  sdlInit_count++;

  myflags = SDL_WasInit(flags);
  if (myflags == flags)
  {
    /* all wanted is initialized -> nothing to do */
    return FALSE;
  }
  /* we initialize only needed flags */
  flags = flags - myflags;

  if (SDL_WasInit(SDL_INIT_EVERYTHING)&&SDL_INIT_EVERYTHING)
    {
      /* something initialized */
      if (SDL_InitSubSystem(flags)<0)
      {
        GB.Error(SDL_GetError());
	return TRUE;
      }
    }
  else
    {
      /* nothing initialized */
      if (SDL_Init(flags)<0)
      {
        GB.Error(SDL_GetError());
	return TRUE;
      }
    }

  return FALSE;
}

void Quit(void)
{
  sdlInit_count--;
  if (sdlInit_count<1)
      SDL_Quit();
}

GB_DESC *GB_CLASSES[] =
{
  Cquerycdrom,
  Ctracks, Ctrack,
  Ccdrom,
  NULL
};

void *GB_SDL_1[] = {

  (void *)1,

  (void *)Init,
  (void *)Quit,

  NULL
};

int GB_INIT(void)
{
  if (Init(SDL_INIT_CDROM | SDL_INIT_NOPARACHUTE))
    return FALSE;

  return TRUE;
}

void GB_EXIT()
{
  Quit();
}
