/***************************************************************************

  reserved_t.h

  Template for reserved keywords table and subroutines table.

  (c) 2000-2005 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#include "gb_common.h"
#include "gb_pcode.h"
#include "gb_type_common.h"
#include "gb_reserved.h"


PUBLIC COMP_INFO COMP_res_info[] =
{
  { "" },

  { "Boolean",      RSF_TYPE,     T_BOOLEAN         },
  { "Byte",         RSF_TYPE,     T_BYTE            },
  { "Date",         RSF_TYPE,     T_DATE            },
  { "Single",       RSF_TYPE,     T_SINGLE          },
  { "Float",        RSF_TYPE,     T_FLOAT           },
  { "Integer",      RSF_TYPE,     T_INTEGER         },
  { "Long",         RSF_TYPE,     T_LONG            },
  { "Short",        RSF_TYPE,     T_SHORT           },
  { "String",       RSF_TYPE,     T_STRING          },
  { "Variant",      RSF_TYPE,     T_VARIANT         },
  { "Object",       RSF_TYPE,     T_OBJECT          },
  { "Pointer",      RSF_TYPE,     T_INTEGER         },
  { "CLASS"                                         },
  { "FUNCTION",                                     },
  { "STRUCT"                                        },
  { "CONST"                                         },
  { "PRIVATE"                                       },
  { "PUBLIC"                                        },
  { "STATIC"                                        },
  { "PROPERTY"                                      },
  { "EVENT"                                         },
  { "INHERITS"                                      },
  { "IMPLEMENTS"                                    },
  { "EXPORT"                                        },
  { "AS"                                            },
  { "OF"                                            },
  { "DIM"                                           },
  { "NEW"                                           },
  { "PROCEDURE"                                     },
  { "SUB"                                           },
  { "RETURN"                                        },
  { "OPTIONAL"                                      },
  { "OUTPUT"                                        },
  { "DO"                                            },
  { "LOOP"                                          },
  { "WHILE"                                         },
  { "UNTIL"                                         },
  { "REPEAT"                                        },
  { "WEND"                                          },
  { "IF"                                            },
  { "THEN"                                          },
  { "ELSE"                                          },
  { "ENDIF"                                         },
  { "END"                                           },
  { "FOR"                                           },
  { "TO"                                            },
  { "FROM"                                          },
  { "STEP"                                          },
  { "NEXT"                                          },
  { "SELECT"                                        },
  { "CASE"                                          },
  { "EXIT"                                          },
  { "BREAK"                                         },
  { "CONTINUE"                                      },
  { "GOTO"                                          },
  { "ME"                                            },
  { "LAST"                                          },
  { "TRY"                                           },
  { "FINALLY"                                       },
  { "CATCH"                                         },
  { "WITH"                                          },
  { "TRUE"                                          },
  { "FALSE"                                         },
  { "SWAP"                                          },
  { "NULL"                                          },
  { "EXTERN"                                        },
  { "EACH"                                          },
  { "IN"                                            },
  { "DEFAULT"                                       },
  { "STOP"                                          },
  { "QUIT"                                          },
  { "RAISE"                                         },
  { "ERROR"                                         },
  { "SUPER"                                         },

  { "PRINT"                                         },
  { "INPUT"                                         },
  { "READ"                                          },
  { "WRITE"                                         },
  { "OPEN"                                          },
  { "CLOSE"                                         },
  { "SEEK"                                          },
  { "APPEND"                                        },
  { "CREATE"                                        },
  { "BINARY"                                        },
  { "LINE"                                          },
  { "FLUSH"                                         },
  { "EXEC"                                          },
  { "SHELL"                                         },
  { "WAIT"                                          },
  { "KILL"                                          },
  { "RENAME"                                        },
  { "COPY"                                          },
  { "INC"                                           },
  { "DEC"                                           },
  { "MKDIR"                                         },
  { "RMDIR"                                         },
  { "WATCH"                                         },
  { "LINK"                                          },
  { "LOCK"                                          },
  { "UNLOCK"                                        },
  { "LIBRARY"                                       },

  { ":"                                                         },
  { ";"                                                         },
  { ","                                                         },
  { "..."                                                       },
  { "#"                                                         },
  { "@"                                                         },
  { "{"                                                         },
  { "}"                                                         },
  { "=",            RSF_OP2S,     OP_EQUAL,     4,    C_EQ      },
  { "==",           RSF_OP2S,     OP_NEAR,      4,    C_NEAR    },
  { "(",            RSF_OPP,      OP_LBRA,      12              },
  { ")",                                                        },
  { ".",            RSF_OP2,      OP_PT,        20              },
  { "!",            RSF_OP2,      OP_EXCL,      20              },
  { "+",            RSF_OP2,      OP_PLUS,      5,    C_ADD     },
  { "-",            RSF_OP2,      OP_MINUS,     5,    C_SUB     },
  { "*",            RSF_OP2,      OP_STAR,      6,    C_MUL     },
  { "/",            RSF_OP2,      OP_SLASH,     6,    C_DIV     },
  { "^",            RSF_OP2S,     OP_FLEX,      7,    C_POW     },
  { "&",            RSF_OPN,      OP_AMP,       8,    C_CAT     },
  { ">",            RSF_OP2S,     OP_GT,        4,    C_GT      },
  { "<",            RSF_OP2S,     OP_LT,        4,    C_LT      },
  { ">=",           RSF_OP2S,     OP_GE,        4,    C_GE      },
  { "<=",           RSF_OP2S,     OP_LE,        4,    C_LE      },
  { "<>",           RSF_OP2S,     OP_NE,        4,    C_NE      },
  { "[",            RSF_OPP,      OP_LSQR,      12              },
  { "]",            RSF_NONE,     OP_RSQR                       },
  { "AND",          RSF_OP2SM,    OP_AND,       2,    C_AND     },
  { "OR",           RSF_OP2SM,    OP_OR,        2,    C_OR      },
  { "NOT",          RSF_OP1,      OP_NOT,       10,   C_NOT     },
  { "XOR",          RSF_OP2SM,    OP_XOR,       2,    C_XOR     },
  { "\\",           RSF_OP2S,     OP_DIV,       6,    C_QUO     },
  { "DIV",          RSF_OP2S,     OP_DIV,       6,    C_QUO     },
  { "MOD",          RSF_OP2S,     OP_MOD,       6,    C_REM     },
  //{ "IS",           RSF_OP2,      OP_IS,        8,    C_IS      },

  { "LIKE",         RSF_OP2S,     OP_LIKE,      4,    C_LIKE    },
  { "&/",           RSF_OPN,      OP_FILE,      9,    C_FILE    },
  
  { "+=",           RSF_ASGN,     RS_PLUS       },
  { "-=",           RSF_ASGN,     RS_MINUS      },
  { "*=",           RSF_ASGN,     RS_STAR       },
  { "/=",           RSF_ASGN,     RS_SLASH      },
  { "\\=",          RSF_ASGN,     RS_BSLASH     },
  { "&=",           RSF_ASGN,     RS_AMP        },
  { "&/=",          RSF_ASGN,     RS_FILE       },

  { NULL }
};


PUBLIC SUBR_INFO COMP_subr_info[] =
{
  { "Left$",              0,  0,  1,  2 },   
  { "Left",               0,  0,  1,  2 },   

  { "Mid$",               1,  0,  2,  3 },   
  { "Mid",                1,  0,  2,  3 },   

  { "Right$",             2,  0,  1,  2 },   
  { "Right",              2,  0,  1,  2 },   

  { "Len",                3,  0,  1     },   

  { "Space$",             4,  0,  1     },   
  { "Space",              4,  0,  1     },   

  { "String$",            5,  0,  2     },   
  { "String",             5,  0,  2     },   

  { "Trim$",              6,  0,  1     },   
  { "Trim",               6,  0,  1     },   

  { "LTrim$",             6,  1,  1     },   
  { "LTrim",              6,  1,  1     },   

  { "RTrim$",             6,  2,  1     },   
  { "RTrim",              6,  2,  1     },   

  { "Upper$",             7,  0,  1     },   
  { "Upper",              7,  0,  1     },   
  { "UCase$",             7,  0,  1     },   
  { "UCase",              7,  0,  1     },   

  { "Lower$",             8,  0,  1     },   
  { "Lower",              8,  0,  1     },   
  { "LCase$",             8,  0,  1     },   
  { "LCase",              8,  0,  1     },   

  { "Chr$",               9,  0,  1     },   
  { "Chr",                9,  0,  1     },   

  { "Asc",               10,  0,  1,  2 },   

  { "InStr",             11,  0,  2,  3 },   

  { "RInStr",            12,  0,  2,  3 },   /* CODE_RINSTR */

  { "Subst$",            13,  0,  1, 63 },   
  { "Subst",             13,  0,  1, 63 },   

  { "Replace$",          14,  0,  3,  4 },   
  { "Replace",           14,  0,  3,  4 },   

  { "Split",             15,  0,  1,  3 },   

  { "Conv",              16,  0,  3     },   
  { "Conv$",             16,  0,  3     },   

  { "Abs",               17,  0,  1     },   /* CODE_ABS */
  { "Int",               18,  0,  1     },   
  { "Fix",               19,  0,  1     },   
  { "Sgn",               20,  0,  1     },   

  { "Frac",              21,  1,  1     },   
  { "Log",               21,  2,  1     },   
  { "Exp",               21,  3,  1     },   
  { "Sqr",               21,  4,  1     },   
  { "Sin",               21,  5,  1     },   
  { "Cos",               21,  6,  1     },   
  { "Tan",               21,  7,  1     },   
  { "Atn",               21,  8,  1     },   
  { "Atan",              21,  8,  1     },   
  { "Asn",               21,  9,  1     },   
  { "Asin",              21,  9,  1     },   
  { "Acs",               21, 10,  1     },   
  { "Acos",              21, 10,  1     },   
  { "Deg",               21, 11,  1     },   
  { "Rad",               21, 12,  1     },   
  { "Log10",             21, 13,  1     },   
  { "Sinh",              21, 14,  1     },   
  { "Cosh",              21, 15,  1     },   
  { "Tanh",              21, 16,  1     },   
  { "Asnh",              21, 17,  1     },   
  { "Asinh",             21, 17,  1     },   
  { "Acsh",              21, 18,  1     },   
  { "Acosh",             21, 18,  1     },   
  { "Atnh",              21, 21,  1     },   
  { "Atanh",             21, 21,  1     }, 
  { "Exp2",              21, 20,  1     },  
  { "Exp10",             21, 21,  1     },  
  { "Log2",              21, 22,  1     },  
  { "Cbr",               21, 23,  1     },  
  { "Expm",              21, 24,  1     },  
  { "Logp",              21, 25,  1     },  

  { "Pi",                22,  0,  0,  1 },   
  { "Round",             23,  0,  1,  2 },   
  { "Randomize",         24,  0,  0     },   
  { "Rnd",               25,  0,  0,  2 },   
  { "Min",               26,  0,  2, 63 },   
  { "Max",               27,  0,  2, 63 },   /* CODE_MAX */

  { "If",                28,  0,  2,  3 },   
  { "IIf",               28,  0,  2,  3 },   
  { "Choose",            29,  0,  1, 63 },   

  { "Array",             30,  0,  1, 63 },
  
  { "Atan2",             31,  1,  2     },
  { "Atn2",              31,  1,  2     },
  { "Ang",               31,  2,  2     },
  { "Hyp",               31,  3,  2     },
  { "Mag",               31,  3,  2     },

  { "BClr",              35,  1,  2     },   
  { "BSet",              35,  2,  2     },   
  { "BTst",              35,  3,  2     },   
  { "BChg",              35,  4,  2     },   
  { "Shl",               35,  5,  2     },   
  { "Shr",               35,  6,  2     },   
  { "Rol",               35,  7,  2     },   
  { "Ror",               35,  8,  2     },   

  { "IsBoolean",         42,  1,  1     },   
  { "IsByte",            42,  2,  1     },   
  { "IsShort",           42,  3,  1     },   
  { "IsInteger",         42,  4,  1     },   
  { "IsLong",            42,  5,  1     },   
  { "IsSingle",          42,  6,  1     },   
  { "IsFloat",           42,  7,  1     },   
  { "IsDate",            42,  8,  1     },   
  { "IsString",          42,  9,  1     },   
  { "IsNull",            42,  15, 1     },   
  { "IsObject",          42,  16, 1     },   
  { "IsNumber",          42,  17, 1     },   

  { "Boolean?",          42,  1,  1     },   
  { "Byte?",             42,  2,  1     },   
  { "Short?",            42,  3,  1     },   
  { "Integer?",          42,  4,  1     },   
  { "Long?",             42,  5,  1     },   
  { "Single?",           42,  6,  1     },   
  { "Float?",            42,  7,  1     },   
  { "Date?",             42,  8,  1     },   
  { "String?",           42,  9,  1     },   
  { "Null?",             42,  15, 1     },   
  { "Object?",           42,  16, 1     },   
  { "Number?",           42,  17, 1     },   

  { "TypeOf",            43,  0,  1     },   

  { "CBool",             44,  1,  1     },   
  { "CByte",             44,  2,  1     },   
  { "CShort",            44,  3,  1     },   
  { "CInt",              44,  4,  1     },   
  { "CInteger",          44,  4,  1     },   
  { "CLng",              44,  5,  1     },   
  { "CLong",             44,  5,  1     },   
  { "CSng",              44,  6,  1     },   
  { "CSingle",           44,  6,  1     },   
  { "CFlt",              44,  7,  1     },   
  { "CFloat",            44,  7,  1     },   
  { "CDate",             44,  8,  1     },   
  { "CStr",              44,  9,  1     },   
  { "CString",           44,  9,  1     },   

  { "Bin$",              45,  0,  1,  2 },   
  { "Bin",               45,  0,  1,  2 },   

  { "Hex$",              46,  0,  1,  2 },   
  { "Hex",               46,  0,  1,  2 },   

  { "Val",               47,  0,  1     },   

  { "Str$",              48,  0,  1     },   
  { "Str",               48,  0,  1     },   

  { "Format$",           49,  0,  1,  2 },   
  { "Format",            49,  0,  1,  2 },   

  { "Timer",             50,  0,  0     },   

  { "Now",               51,  0,  0     },   

  { "Year",              52,  1,  1     },   
  { "Month",             52,  2,  1     },   
  { "Day",               52,  3,  1     },   
  { "Hour",              52,  4,  1     },   
  { "Minute",            52,  5,  1     },   
  { "Second",            52,  6,  1     },   
  { "WeekDay",           52,  7,  1     },   

  { "Date",              53,  0,  0,  6 },   
  { "Time",              54,  0,  0,  3 },   

  { "DateAdd",           55,  0,  3     },   
  { "DateDiff",          55,  1,  3     },   
  
#ifndef __EVAL_RESERVED_C   
  { "Error",             56,  0,  0,  2 },   

  { "Eval",              57,  0,  1,  2 },   

  { "Beep",              58,  0,  0     },   

  { "Wait",              59,  0,  0,  1 },   

  { "Open",              60,  0,  2     },   
  { "Close",             61,  0,  1     },   
  { "Input",             62,  0,  0,  1 },   
  { "LineInput",         63,  0,  1     },   
  { "Print",             64,  0,  1, 63 },   
  { "Read",              65,  0,  1,  2 },   
  { "Write",             66,  0,  1,  2 },   
  { "Flush",             67,  0,  1     },   
  
  { "Lock",              68,  0,  1     },   
  { "Unlock",            68,  1,  1     },   
  
  { "InputFrom",         69,  0,  1     },   
  { "OutputTo",          69,  1,  1     },   
#endif
  { "Eof",               70,  0,  1     },   
  { "Lof",               71,  0,  1     },   
  { "Seek",              72,  0,  1,  3 },   
#ifndef __EVAL_RESERVED_C   
  { "Kill",              73,  0,  1     },   
  { "Mkdir",             74,  0,  1     },   
  { "Rmdir",             75,  0,  1     },   
  { "Rename",            76,  0,  2     },   
  { "Copy",              77,  0,  2     },   
  { "Link",              78,  0,  2     },   
#endif
  { "Exist",             79,  0,  1     },   
  { "Access",            80,  0,  1,  2 },   
  { "Stat",              81,  0,  1     },   

  { "Temp",              82,  0,  0,  1 },   
  { "Temp$",             82,  0,  0,  1 },   

  { "IsDir",             83,  0,  1     },   
  { "Dir?",              83,  0,  1     },   

  { "Dir",               84,  0,  1,  2 },   
  { "RDir",              85,  0,  1,  2 },   

#ifndef __EVAL_RESERVED_C   
  { "Exec",              86,  0,  3     },   
  { "Shell",             86,  1,  3     },   
#endif

  { "Alloc",             87,  0,  1,  2 },   
  { "Free",              88,  0,  1     },   
  { "Realloc",           89,  0,  2,  3 },   
  { "StrPtr",            90,  0,  1     },
  
  { "SConv",             91,  0,  1     },
  { "SConv$",            91,  0,  1     },
  { "DConv",             91,  1,  1     },
  { "DConv$",            91,  1,  1     },

  /*
  { "_EventOff",         94,  0,  0     },   
  { "_EventOn",          95,  0,  0     },   
  */

  { NULL }
};

PUBLIC TABLE *COMP_res_table;
PUBLIC TABLE *COMP_subr_table;


PUBLIC void RESERVED_init(void)
{
  COMP_INFO *info;
  SUBR_INFO *subr;
  /*CONST_INFO *cst;*/

  /* Table des mots rservs */

  TABLE_create(&COMP_res_table, 0, TF_IGNORE_CASE);
  for (info = &COMP_res_info[0]; info->name; info++)
    TABLE_add_symbol(COMP_res_table, info->name, strlen(info->name), NULL, NULL);

  #ifdef DEBUG
  printf("Table des mots rservs:\n");
  TABLE_print(COMP_res_table, TRUE);
  #endif

  /* Table des routines intgres */

  TABLE_create(&COMP_subr_table, 0, TF_IGNORE_CASE);
  for (subr = &COMP_subr_info[0]; subr->name; subr++)
  {
    if (subr->max_param == 0)
      subr->max_param = subr->min_param;

    TABLE_add_symbol(COMP_subr_table, subr->name, strlen(subr->name), NULL, NULL);
  }

  #ifdef DEBUG
  printf("Table des routines intgres:\n");
  TABLE_print(COMP_subr_table, TRUE);
  #endif

  /* Table des constantes */

  /*
  TABLE_create(&COMP_const_table, 0, TF_IGNORE_CASE);
  for (cst = &COMP_const_info[0]; cst->name; cst++)
    TABLE_add_symbol(COMP_const_table, cst->name, strlen(cst->name), NULL, NULL);
  */
}


PUBLIC void RESERVED_exit(void)
{
  TABLE_delete(&COMP_res_table);
  TABLE_delete(&COMP_subr_table);
}


PUBLIC SUBR_INFO *SUBR_get(const char *subr_name)
{
  long index;

  if (!TABLE_find_symbol(COMP_subr_table, subr_name, strlen(subr_name), NULL, &index))
    return NULL;
  else
    return &COMP_subr_info[index];
}


PUBLIC SUBR_INFO *SUBR_get_from_opcode(ushort opcode, ushort optype)
{
  SUBR_INFO *si;

  for (si = COMP_subr_info; si->name; si++)
  {
    if (si->opcode == opcode)
    {
      if (si->min_param != si->max_param)
        return si;
      else if (si->optype == optype || si->optype == 0)
        return si;
    }
  }

  /*ERROR_panic("SUBR_get_from_opcode: SUBR not found !");*/
  return NULL;
}


/*
PUBLIC CONST_INFO *CONST_get(char *cst_name)
{
  long index;

  if (!TABLE_find_symbol(COMP_const_table, cst_name, strlen(cst_name), NULL, &index))
    return NULL;
  else
    return &COMP_const_info[index];
}


PUBLIC CONST_INFO *CONST_get_from_index(short index)
{
  CONST_INFO *ci;

  for (ci = COMP_const_info; ci->name; ci++)
  {
    if (ci->index == index)
      return ci;
  }

  return NULL;
}
*/
